# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....commons.types.user_tenant_association import UserTenantAssociation
from ....core.datetime_utils import serialize_datetime
from ....core.pydantic_utilities import pydantic_v1


class ListTenantsForUserResponse(pydantic_v1.BaseModel):
    items: typing.Optional[typing.List[UserTenantAssociation]] = None
    has_more: bool = pydantic_v1.Field()
    """
    Set to true when there are more pages that can be retrieved.
    """

    url: str = pydantic_v1.Field()
    """
    A url that may be used to generate these results.
    """

    next_url: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    A url that may be used to generate fetch the next set of results.
    Defined only when `has_more` is set to true
    """

    cursor: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    A pointer to the next page of results. Defined
    only when `has_more` is set to true
    """

    type: typing.Literal["list"] = pydantic_v1.Field()
    """
    Always set to `list`. Represents the type of this object.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
